/**
 * Name:Daniel Greco
 * Filename: Host.java
 * Description: This file will create a new host thread, with the given game 
 * type, and host name 
 */ 

import java.io.*;
import java.net.*;

public class Host {
    String name;
    int game;
    
    /**
     * Default Constructor for class Host. Note that this is private
     * Therefore it can never be called from outside.
     * 
     */
    private Host()
    {
        
    }
    
    /**
     * Constructor for class Host. This is the only constructor that can be 
     * called from the outside
     * @param name is a string that will hold the host's name that they gave in
     * the main menu
     * @param game is an integer that represents what game they'll be hosting.
     * 
     */
    public Host(String name, int game)
    {
        this.name = name;
        this.game = game;
    }
    
    
    /**
     * Run will be called at creation and will created a host thread that will 
     * then listen for a client to connect with
     * 
     */
    public void run() throws IOException {
        ServerSocket serverSocket = null;
        //used to run forever
        boolean listening = true;

        //try to create a serversocket on port 4444
        try {
            serverSocket = new ServerSocket(MainMenu.PORT + this.game);
        } catch (IOException e) {
            throw e;
            
        }
        
        //run until the host quits the program
        while (listening)
            new HostThread(serverSocket.accept(), name, game).start();

        //close the sockets!
        serverSocket.close();
    }
}